//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  DimGray
#property indicator_width1  2
#property indicator_level1  80
#property indicator_level2  20
#property indicator_style2  STYLE_DOT
#property indicator_levelcolor DarkGray
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int StochPeriod      = 14;
extern int StochSlowing     =  3;
extern int StochSignal      =  3;
extern int StochSignalMode  = MODE_SMA;
extern int StochPrice       =  0;
extern int VolatilityPrice  = PRICE_CLOSE;
extern int VolatilityPeriod =  5;
extern int VolatilitySmooth = 10;

double sto[];
double stosig[];
double price[];
double sum[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,sto);
      SetIndexBuffer(1,stosig);
      SetIndexBuffer(2,price);
      SetIndexBuffer(3,sum);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int k,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
      for(int i = limit; i >= 0; i--)
      {
         price[i]   =  iMA(NULL,0,1,0,MODE_SMA,VolatilityPrice,i);
         sum[i]     =  0;       for (k = 0; k<VolatilityPeriod; k++) sum[i] += MathAbs(price[i+k]-price[i+k+1]);
         double avg =  sum[i];  for (k = 1; k<VolatilitySmooth; k++) avg    += sum[i+k];
                avg /= VolatilitySmooth;
         
                //
                //
                //
                //
                //
                
                if (avg!=0 && sum[i]!=0)
                     int stoPer = MathFloor(MathMin(MathMax(StochPeriod/(sum[i]/avg),StochPeriod/2.0),StochPeriod*5.0));
                else     stoPer = StochPeriod;
                sto[i]    = iStochastic(NULL,0,stoPer,StochSignal,StochSlowing,StochSignalMode,StochPrice,MODE_MAIN  ,i);
                stosig[i] = iStochastic(NULL,0,stoPer,StochSignal,StochSlowing,StochSignalMode,StochPrice,MODE_SIGNAL,i);
      }
   return(0);
}